/* 
 * Copyright (C) International Computer Science Institute, 1995/1996.  COPYRIGHT
 * NOTICE: This code is provided "AS IS" WITHOUT ANY WARRANTY and is subject
 * to the terms of the SATHER LIBRARY GENERAL PUBLIC LICENSE contained in
 * the file "Doc/License" of the Sather distribution.  The license is also
 * available from ICSI, 1947 Center St., Suite 600, Berkeley CA 94704, USA.
 * ---> Please email bugs to "psather-bugs@icsi.berkeley.edu". 
 *
 * Memory allocation and deallocation
 *
 * Version 1.0 (released for 1.0.9) by Claudio Fleiner (fleiner@icsi.berkeley.edu)
 */
#include <stdio.h>
#include <malloc.h>
#include "pSather.h"
#include "memory.h"


static void reply_alloc(vnn_t from,void **p,void *mem,ta_sema_t ta)
{
	*p=mem;
	TA_SEMA_SIGNAL(ta);
}

static void request_alloc(vnn_t from,void **p,int size,sema_t ta)
{
	void *n;
	MALLOC(n,size);
	am_reply_3(from,(handler_3_t)reply_alloc,(long)p,(long)n,(long)ta);
}

FOB r_alloc(vnn_t where,int size)
{
	void *p;
	TA_SEMAPHORE(ta);
	am_request_3(where,(handler_3_t)request_alloc,(long)&p,(long)size,(long)ta);
	TA_SEMA_WAIT(ta);
	return RECVFOB(p,where);
}

static void request_free(vnn_t from,void *p)
{
	FREE(p);
}

void r_free(FOB p)
{
	am_request_1(WHERE(p),(handler_1_t)request_free,(long)SENDFOBHOME(p));
}
